import pygame, time
from pygame.locals import *
from math import sin, cos, radians

# Init:
pygame.init()
rot = (255, 0, 0) weiss = (255, 255, 255) schwarz = (0, 0, 0)
canvas = pygame.display.set_mode((400, 400))
canvas.fill(weiss)

# Mittelpunkt der Uhr:
MX = 200
MY = 200
MP = ((MX, MY))

# erzeugt einen Punkt mit Abstand r vom Mittelpunkt
# für t Minuten nach der vollen Stunde
# bzw t Sekunden nach der vollen Minute
def punkt(r, t):
    alpha = radians(t * 6 - 90)
    x1 = int(MX + r * cos(alpha))
    y1 = int(MY + r * sin(alpha))
    return((x1, y1))
# end punkt()

# Minutenmarken:
for i in range(60):
    pygame.draw.circle(canvas, schwarz, punkt(190, i), 2)
# Stundenmarken (bzw 5-Minutenmarken):
for i in range(12):
    pygame.draw.circle(canvas, schwarz, punkt(190, i * 5), 4)

s1 = 0
mainloop = True
while mainloop:
    zeit = time.localtime()
    s = zeit.tm_sec
    m = zeit.tm_min
    h = zeit.tm_hour
    if h > 12:
        h = h - 12
    hm = (h + m / 60.0) * 5
    if s1 != s:
        pygame.draw.circle(canvas, weiss, MP, 182)                # Löschen
        pygame.draw.line(canvas, schwarz, MP, punkt(120, hm), 6)  # Std-Zeiger
        pygame.draw.line(canvas, schwarz, MP, punkt(170, m), 4)   # Min-Zeiger
        pygame.draw.line(canvas, rot, MP, punkt(180, s), 2)       # Sek-Zeiger
        s1 = s
        pygame.display.set_caption("Aktuelle Zeit: " + time.asctime())
        pygame.display.update()
		
        # Event zum Beenden des Programms behandeln:
        for event in pygame.event.get():
            if event.type == QUIT or (event.type == KEYUP and event.key == K_ESCAPE):
                mainloop = False
        time.sleep(0.1)
pygame.quit()
